<?php

/**
 * @file
 * Provide views data.
 */

/**
 * Implements hook_views_data().
 */
function rules_link_views_data() {
  $data = array();

  foreach (rules_link_get_links() as $name => $rules_link) {
    $entity = entity_get_info($rules_link->entity_type);
    $data[$entity['base table']][$name]['field'] = array(
      'title' => $rules_link->title,
      'help' => t('Execute the selected rules link.'),
      'handler' => 'views_handler_field_rules_link',
      'real field' => $entity['entity keys']['id'],
      'rules link name' => $name,
    );
  }
  return $data;
}

/**
 * Renders the links for views.
 */
class views_handler_field_rules_link extends views_handler_field {
  function render($value) {
    $rules_link = rules_link_load($this->definition['rules link name']);
    return rules_link_render_link($rules_link, $this->get_value($value), drupal_get_destination());
  }
}
